<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Kode Proyek</label>
            <b-form-select
              v-model="filter.code_project"
              :options="projectOptions"
              size="lg"
            ></b-form-select>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nomor Surat</label>
            <b-form-input
              size="lg"
              placeholder="Masukkan Nomor Surat"
              v-model="filter.code"
            ></b-form-input>
          </div>

        </div>

        <div class="row">

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nama Proyek</label>
            <b-form-input
                  id="input-large"
                  size="lg"
                  disabled
                  placeholder="Masukkan Nama Proyek"
                  v-model="selectedProject.projectName"
                ></b-form-input>
          </div>

           <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Tanggal Surat</label>
            <b-form-input
              id="input-large"
              size="lg"
              type="date"
              v-model="filter.date"
            ></b-form-input>
          </div>

        </div>

        <div class="d-flex justify-content-end">
          <button class="btn btn-primary btn-md" @click="onShowData">
            <i class="flaticon2-search-1" ></i> Tampilkan
          </button>
        </div>
      </div>
    </div>

    <div class="card card-custom p-5 gutter-b">
      <div class="d-flex my-3 justify-content-end">
        <vue-excel-xlsx
            :data="data.letter"
            :columns="columns"
            :filename="'Lettering'"
            :sheetname="'letter'"
            >
          <button class="btn btn-success btn-md" :disabled="data.letter.length === 0" >
              <i class="fa fa-file-excel"></i>
              Excel
            </button>
        </vue-excel-xlsx>
        
        <button class="btn btn-warning btn-md" @click="onExportPDF" :disabled="data.letter.length === 0"  >
          <i class="fa fa-file-pdf"></i>
           PDF
        </button>
      </div>

      <div class="card-body p-0">
        <div class="table-responsive" ref="contentPDF" id="contentPDF">
          <table
            class="table table-head-custom table-vertical-center table-head-bg table-borderless"
          >
            <thead>
              <tr class="text-left">
                <th style="min-width: 50px" class="pl-7">
                <span class="text-dark-75">No</span>
                </th>
                <th style="min-width: 100px" class="pl-7">
                  <span class="text-dark-75">Nickname</span>
                </th>
                <th style="min-width: 100px">Type</th>
                <th style="min-width: 100px">Tanggal Surat</th>
                <th style="min-width: 100px">Nomor Surat</th>
                <th style="min-width: 100px">Subject</th>
                <th style="min-width: 100px">PIC</th>
                <th style="min-width: 100px">Dari</th>
                <th style="min-width: 100px">Tujuan</th>
                <th style="min-width: 101px">Follow Up</th>
                 <th style="min-width: 101px">File</th>
              </tr>
            </thead>

            <tbody>
              <template v-for="(item, i) in this.data.letter">
                <tr v-bind:key="i">
                  <td class="pl-0">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ item.no}}
                  </span>
                </td>
                  <td class="pl-0 ">
                    <span
                      class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.nickname }}
                    </span>
                  </td>

                  <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.type }}
                    </span>
                  </td>

                  <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.tanggal_surat }}
                    </span>
                  </td>

                   <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.nomor_surat }}
                    </span>
                  </td>

                   <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.subject }}
                    </span>
                  </td>

                   <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.pic }}
                    </span>
                  </td>

                   <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.from }}
                    </span>
                  </td>

                   <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.to }}
                    </span>
                  </td>

                  <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.follow_up }}
                    </span>
                  </td>

                  <td>
                    <span
                      class="text-dark-75 font-weight-bolder d-block font-size-lg"
                    >
                      {{ item.file }}
                    </span>
                  </td>
                </tr>
              </template>
            </tbody>
          </table>
        </div>
      </div>
    </div>
    

    
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import { GET_REPORT_LETTERING } from "@/core/services/store/report-lettering.module";
import { mapGetters } from "vuex";
import { GET_PROJECT_DETAIL } from "@/core/services/store/project.module.js";
import jsPDF from 'jspdf';
import html2canvas from 'html2canvas';


export default {
  name: "lettering",
  data() {
    return {
      filter: {
        date: null,
        code_project: null,
        code: null
      },
        selectedProject: {
        code:null,
        ownerName: null,
        projectName: null,
        status: null,
        contractNumber: null,
        primpro:null,
        revisi:null
      },
      columns : [
                   {
                        label: "No",
                        field: "no",
                    },
                    {
                        label: "Nickname",
                        field: "nickname",
                    },
                    {
                        label: "Type",
                        field: "type",
                    },
                    {
                        label: "Tanggal Surat",
                        field: "tanggal_surat",
                    },
                    {
                        label: "No Surat",
                        field: "nomor_surat",
                    },
                    {
                        label: "Subject",
                        field: "subject",
                    },
                    {
                        label: "PIC",
                        field: "pic",
                    },
                    {
                        label: "Dari",
                        field: "from",
                    },
                    {
                        label: "Tujuan",
                        field: "to",
                    },
                     {
                        label: "Follow Up",
                        field: "follow_up",
                    },
                ],
      data: {
        letter:[],
      },
      options: {
        followUp: [
          { value: 1, text: "YA" },
          { value: 0, text: "TIDAK" }
        ],
        letter_type: [
          { value: "in", text: "In" },
          { value: "out", text: "Out" },
          { value: "reply", text: "Reply" }
        ],
        project:[
           { value:null, text:null}
        ],
        pic:[
           { value:null, text:null}
        ]
      },
      form: {
        code : null,
        id_project: null,
        letter_type: null,
        date: null,
        subject: null,
        pic_code: null,
        from : null,
        to: null,
        follow_up:null
      }
    };
  },
  methods: {

    onPDF(){
      console.log(this.currentReportLettering)
    },
    onShowData(){
        this.$store.dispatch(GET_REPORT_LETTERING, {params:this.filter})
        .then(() => this.mappingDataLetter(this.currentReportLettering));
    },

    mappingDataProject(projectList){
        this.options.project = []
        projectList.map(project => this.options.project.push({
            text:project.code + '-' + project.nickname,
            value:project.code
        }))
    },
    mappingDataPic(listpic){
        this.options.pic = []
        listpic.map(pic => this.options.pic.push({
            text:pic.code + '-' + pic.name,
            value:pic.code
        }))
    },

    mappingDataLetter(listLetter){
        let no = 0;
        this.data.letter = []
        listLetter.map(letter => this.data.letter.push({
              no: no = no +1,
              nickname: letter.project.nickname,
              type: letter.letter_type,
              tanggal_surat: letter.date,
              nomor_surat:letter.code,
              subject: letter.subject,
              pic: letter.pic_code,
              from: letter.from,
              to: letter.to,
              follow_up:letter.follow_up === 1 ? 'YA' : 'NO',
              file:letter.file
        }))
    },

 
    mappingFormToObject(form){
        Object.assign(this.data.letter, {
            code : form.code,
            project : {
                    code : form.id_project,
                    name: null,
                    nickname :null,
            },
            letter_type : form.letter_type,
            date : form.date,
            subject : form.subject,
            pic : {
                code : form.pic_code,
                name: null
            },
            from : form.from,
            to : form.to
      });
    },

    onExportPDF(){
      window.html2canvas = html2canvas;
       var doc = new jsPDF("l","pt","A3");
       doc.setFontSize(100)
       doc.html(document.querySelector("#contentPDF"),{
         callback:function(pdf){
     
           pdf.save("Lettering.pdf");
         }
       },true)

       console.log("pdfdoc",doc)
  
    }

  },
  async mounted() {
    await this.$store.dispatch(SET_BREADCRUMB, [{ title: "Lettering" }]);
    await this.$store.dispatch(GET_PROJECT_DETAIL, "design" ).then(
        () => this.mappingDataProject(this.currentProjectDetails)
    );
    
  },
  computed: {
    ...mapGetters(["currentReportLettering","currentPics","currentProjectDetails"]),
    projectOptions(){
          var result =  [{ value: null, text: "Pilih Proyek" }];
              if(this.currentProjectDetails != undefined){
              this.currentProjectDetails.map(project => {
                result.push( {
                  value: project.code,
                  text: project.code + "-" + project.nickname
                });
              });
          }   
        return result;
      },

      currentProjectCode() { 
        return this.filter.code_project; 
      }

  },
   watch: {
    currentProjectCode(value) {
      if (!value) {
        Object.assign(this.selectedProject, {
          id_project:null,
          ownerName: null,
          projectName: null,
          status: null,
          contractNumber: null,
          revisi:null,
          primpro:null
        });


        return;
      }

      var resultProject = this.currentProjectDetails.filter(c=>c.code === value )

      Object.assign(this.selectedProject, {
        id_project: resultProject[0].code,
        ownerName: resultProject[0].owner,
        projectName: resultProject[0].name,
        status: resultProject[0].status,
        contractNumber: resultProject[0].contract_no,
        primpro : resultProject[0].leader,
        revisi:resultProject[0].site_document_revision
      });

      //this.getDocumentSiteByProject(value);

    }
  },
};
</script>

<style></style>
